#!/usr/bin/env python
#-*- coding:utf-8 -*-
##
## zresify.py
##
##  Created on: Feb 1, 2015
##      Author: aign
##

#
#==============================================================================
import os
import sys

#
#==============================================================================
def read_file(fp):
    """
        Reads formula from file.
    """

    buff = fp.readlines()
    nv = 0
    iv = 0
    cnf = []

    for line in buff:
        if line and line[0] != 'p' and line[0] != 'c':
            cl = [int(l) for l in line.split()[:-1]]
            nv = max([abs(l) for l in cl] + [nv])

            cnf.append(cl)
        if line[:13] == 'c n orig vars':
            iv = int(line[13:].strip())

    return nv, iv, cnf


#
#==============================================================================
if __name__ == '__main__':
    d = sys.argv[1]
    newd = '{0}-zres'.format(os.path.basename(d.rstrip('/')))
    os.mkdir(newd)

    for p, ds, fs in os.walk(d):
        for f in fs:
            if f.strip()[-6:-4] == '-p':
                forig = os.path.join(p, f)
                fnew = os.path.join(newd, f[:-6] + f[-4:])

                with open(forig, 'r') as fp:
                    nv, iv, cnf = read_file(fp)

                with open(fnew, 'w') as fp:
                    for i in xrange(iv + 1, nv + 1):
                        print >> fp, 'cd', i
                    print >> fp, 'p cnf', nv, len(cnf)
                    for cl in cnf:
                        print >> fp, ' '.join([str(l) for l in cl]), ' 0'
